<html>
<?php 
$Segments = $_GET["Segments"];
$Type = $_GET["Type"];
$Which = $_GET["Which"]; //is it bearing or inclination
//variable to set if segements are proporional to area or radius
$SegmentSize = $_GET["SegmentSize"];
//image size will be 2*$n
$n = $_GET["GridSize"];
$LType = $_GET["LType"];

//bring in the site variables
require("../../config.php");
echo "<head><title>" . $Title . "</title>";
echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"$Styles\" /> </head><body>";
echo "<h2>" . $Title. "<br /></h2>";
echo "<p>Polar Diagram of ".ucfirst(strtolower($Which)) . "s</p>";


/*
Dividing by the turn angle and taking the interger result (floor) puts thresult into catagories
Mod combines the results if needed, and adds makes 360=0 for bearings which still leaves -/+90 as a
single group in Gradient that is dealt with later
*/
switch ($Which) {
	case  "BEARING":
		$TableMin = 0;
		switch ($Type)
			{
			case "combi":
				$TableMax = $FullTurn/2;
				$TurnAngle = $FullTurn/(2*$Segments);
				break;
			case "all":
				$TableMax = $FullTurn;
				$TurnAngle = $FullTurn/$Segments;
				break;
			}
		$Operator = "mod(BEARING,$TableMax)/$TurnAngle";
		switch ($LType)
			{
			case "Horz":
				//convert to degrees if needed
				if ($FullTurn == 360)
					{
					$LMod = "*cos(radians(gradient))";
					}
				else
					{
					$Multiplier = 360/$FullTurn;
					$LMod = "*cos(radians(gradient*$Multiplier))";
					}
				break;
			case "Actual":
				$LMod = NULL;
				break;
			}
       		break;
	case "GRADIENT":
		$TableMax = ($FullTurn/4);
		$LMod = NULL;
		switch ($Type)
			{
			case "combi":
				$TableMin = 0;
				$TurnAngle = $FullTurn/(4*$Segments);
				$Operator = "abs(GRADIENT)/$TurnAngle";
				break;
			case "all":
				$TableMin = (-1) * ($FullTurn/4);
				$TurnAngle = $FullTurn/(2*$Segments);
				//by making all angles +tive by adding quater turn,
				//allows odd number of segments by spanning zero
				$Operator = "(GRADIENT+($FullTurn/4))/$TurnAngle";
				break;
			}
		break;
       		}

$DataConnect = mysql_connect("$Connect", "$DatabaseUser", "$DatabasePW")
or die('Could not connect: ' . mysql_error());

mysql_select_db("$DatabaseName",$DataConnect) or die('Could not find Database: ' . mysql_error());

$SQLraw = mysql_query("SELECT sum(length$LMod) as L,floor($Operator) as G from SHOT
left join SHOT_FLAG on SHOT.ID=SHOT_FLAG.SHOT_ID
where SHOT_FLAG.FLAG is NULL
group by G") or die("Could not Query Database: " . mysql_error());

/*
Turn the sql result into a php array that can be manipulated
So as the values for +90 (or equivelent) can be added into the highest group
on the Gradient plots
Add up the totallength and find the max for scaling diagram later
*/

$TotalLength = 0;
$MaxSegment = 0;
while($row =  mysql_fetch_assoc($SQLraw)) 
	{
	$PlotArray[] =  $row;
	$TotalLength+=$row['L'];
	if ($MaxSegment <  $row['L'])
		{
		$MaxSegment = $row['L'];
		}	
	}

//Combine the vertical legs into highest group

if ($Which == "GRADIENT")
	{
	$PlotArray[$Segments-1]['L']+=$PlotArray[$Segments]['L'];
	//Check to see if this is the new max
	if ($MaxSegment <  $PlotArray[$Segments-1]['L'])
		{
		$MaxSegment = $PlotArray[$Segments-1]['L'];
		}
	}



// create a n*n image
$img = imagecreate($n, $n);
$white = imagecolorallocate($img, 255, 255, 255);
$red   = imagecolorallocate($img, 255,   0,   0);
$green = imagecolorallocate($img,   0, 255,   0);


//take each of the results $Plot and scale largest to 95% of half the square
//Remember arc are plotted as elipses using diameter of horz and vert axes
$c = $n/2;
$Slice=0;
foreach($PlotArray as $Plot)
	{
	switch ($SegmentSize)
		{
		case "radius":
			$PlotLength = (0.95* $n * $Plot['L'] / $MaxSegment);
			//echo $Plot['Length']. " part of " .$MaxSegment. " gives ".$PlotLength."<br />";
			break;
		case "area":
			$PlotLength = (0.95* $n * sqrt($Plot['L']) / sqrt($MaxSegment));
			//echo $Plot['Length']. " part of " .$MaxSegment. " gives ".$PlotLength."<br />";
			break;
		}
	//gd draws from 3 o'clock clockwise!!!!
	switch ($Which) {
		case "BEARING":
			$start_arc = ($Slice*$TurnAngle) - ($FullTurn/4);
			$end_arc = (($Slice+1)*$TurnAngle) - ($FullTurn/4);
			break;
		case "GRADIENT":
			$end_arc = (($Slice*$TurnAngle)+$TableMin)*(-1);
			$start_arc = ((($Slice+1)*$TurnAngle)+$TableMin) * (-1);
			break;
		}
	//convert to degrees to plot, if needed
	if ($FullTurn != 360)
		{
		$start_arc = 360 * $start_arc / $FullTurn;
		$end_arc = 360 * $end_arc / $FullTurn;
		}
		
	imagefilledarc($img, $c, $c,$PlotLength, $PlotLength, $start_arc, $end_arc, $red,IMG_ARC_PIE);
	imagefilledarc($img, $c, $c, $PlotLength, $PlotLength, $start_arc, $end_arc, $green,6);
	$Slice++;
	}

ob_start();
imagepng($img);
$data = base64_encode(ob_get_contents());
ob_end_clean();

echo "<img width=$n height=$n border=1 src=\"data:image/png;base64,$data\" alt=\"Polar plot of $which\" />\n";

//Produce table of results
echo "<table border=\"1\"><tr><th>Range</th><th>Length</th></tr>";
echo "<caption> The Table of Results</caption>";
$j = 0;
while ($j < $Segments-1)
	{
	echo "<tr><td>"; 
	echo round($j*$TurnAngle,1). " <= Angle < ". round(($j+1)*$TurnAngle,1);
	echo "</td><td>";
        echo round($PlotArray[$j]['L'],2);
        echo "</td></tr>";
        $j++;
	}
//once more but with <= for upper limit for Gradient
	echo "<tr><td>"; 
	echo round($j*$TurnAngle,1);
	switch ($Which) {
		case "BEARING":
			echo " <= Angle < ";
			break;
		case "GRADIENT":
			echo " <= Angle <= ";
			break;
			}
	echo round(($j+1)*$TurnAngle,1);
	echo "</td><td>";
        echo round($PlotArray[$j]['L'],2);
        echo "</td></tr>";
echo "</table>";
echo "Total length: ". round($TotalLength,2);
// free memory
imagedestroy($img);	

//close data connection
mysql_close($DataConnect);


?>
</body>
</html>
